Leetcode1 Two Sum

描述

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

1.HashMap实现

2.自建一个结构体,用Sort()给数组排序,双指针实现

3.暴力测试,这种方法在LeetCode上提交不会通过

以下第一种方法

public class Solution {
    public static int[] twoSum(int[] numbers, int target) {
        int [] idx=new int[2];
       Map<Integer, Integer> m=new HashMap<Integer,Integer>();
        for(int i=0;i<numbers.length;i++){
            if(m.containsKey(target-numbers[i])){
                idx[0]=m.get(target-numbers[i])+1;
                idx[1]=i+1;
            }
            else{
                m.put(numbers[i],i);
            }
        }

        return idx;
    }
posted @ 2015-04-08 20:36  D_riv  阅读(133)  评论(0编辑  收藏  举报